<?php

defined("_JEXEC") or die;

class JshoppingModelAlias_Generate {

    public function setAliasToGroup($groupType) {
        
        $determine = $this->determinePostData($groupType);

        $tableName = $determine[0];
        $typeID = $determine[1];
        $checkExistAlias = $determine[2];
        $loadTableName = $determine[3];
        
        $groupEmtyAlias = $this->getGroupWithEmptyAlias($groupType, $loadTableName, $typeID);
        $groupFilter = array_filter($groupEmtyAlias);
        
        if (empty($groupFilter)) { 
            return false;
        } else {
            $this->saveAliasToGroup($groupEmtyAlias, $groupType, $tableName, $typeID, $checkExistAlias);
            return true;
        } 
    }

    private function determinePostData($groupType) {
        
        $array_determine = array();
        
        if ($groupType == 'products') {
            $array_determine[] = "product";
            $array_determine[] = "product_id";
            $array_determine[] = "checkExistAlias2Group";
            $array_determine[] = "#__jshopping_products";
            
            return $array_determine;
            
        } else if ($groupType == 'categories') {
            $array_determine[] = "category";
            $array_determine[] = "category_id";
            $array_determine[] = "checkExistAlias1Group";
            $array_determine[] = "#__jshopping_categories";
            
            return $array_determine;
            
        }
        
    }
    
    private function getGroupWithEmptyAlias($groupType, $loadTableName, $typeID) {

        $langueges_tags_array = $this->getAllLanguageTag();
        $database = JFactory::getDBO();
        $groupEmptyAlias = array();
        
        foreach ($langueges_tags_array as $key => $value) {

            $lang_tag = "name_" . $value->lang_code;
            $alias_tag = "alias_" . $value->lang_code;
            $query = "  SELECT `".$typeID."`, `" . $lang_tag . "`
                        FROM `".$loadTableName."`
                        WHERE `" . $alias_tag . "` = ''
                      ";
            $database->setQuery($query);
            $groupEmptyAlias[] = $database->loadObjectList();
            
        }
        return $groupEmptyAlias;
    }

    private function genereteAliasName() {

        $characters = 'abcdefghijklmnopqrstuvwxyz';
        $charactersLength = strlen($characters);
        $randomString = '';

        for ($i = 0; $i < $charactersLength; $i++) {
            $randomString .= $characters[rand(0, $charactersLength - 1)];
        }

        return $randomString;
    }

    private function saveAliasToGroup($groupEmtyAlias, $groupType, $tableName, $typeID, $checkExistAlias) {
        
        $all_tags_languages = $this->getAllLanguageTag();
        $group = JSFactory::getTable($tableName, 'jshop');
        $_alias = JSFactory::getModel("alias");

        foreach ($groupEmtyAlias as $key => $value) {

            foreach ($value as $k => $v) {
                $group->load($v->$typeID);
                foreach ($all_tags_languages as $lang_code) {

                    $generateAliasEmtyName = $this->genereteAliasName();
                    $groupName = "name_".$lang_code->lang_code;
                    $groupAlias = "alias_".$lang_code->lang_code;
                    $nameForGroupAlias = JApplication::stringURLSafe($group->$groupName);
                    
                    if (empty($group->$groupName)) {
                        $group->$groupAlias = '';
                    } else {
                        if (!$_alias->$checkExistAlias($nameForGroupAlias, $lang_code->lang_code, $group->$typeID, 0)) {
                            $group->$groupAlias = $nameForGroupAlias . $generateAliasEmtyName;
                        } else {
                            $group->$groupAlias = $nameForGroupAlias;
                        }
                    }
                }

                $group->store();
            }
        }
    }

    private function getAllLanguageTag() {

        $database = JFactory::getDBO();
        $query = "  SELECT lang_code
                    FROM #__languages
                 ";
        $database->setQuery($query);
        $all_langs_tags = $database->loadObjectList();

        return $all_langs_tags;
    }

}
